﻿
Imports System.Collections.Generic
Imports System.Text
Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports System.Drawing
Imports System.Windows.Forms

Namespace CCTVServer

    Public Class MiniServer
        Private ReadOnly port As Integer
        Private working As Boolean
        Private ReadOnly form1 As frmMain
        Private listener As TcpListener

        Public Sub New(ByVal port As Integer, ByVal form1 As frmMain)
            Me.port = port
            Me.form1 = form1
        End Sub

        Public Sub Start()
            working = True
            Dim serverThread As New Thread(New ThreadStart(AddressOf serverLoop))
            serverThread.Name = "serverThread"
            serverThread.IsBackground = True
            serverThread.Start()
        End Sub

        Public Sub [Stop]()
            working = False
            listener.[Stop]()
        End Sub

        Private Sub serverLoop()
            listener = New TcpListener(IPAddress.Any, port)
            listener.Start()
            While working
                Try
                    Dim client As TcpClient = listener.AcceptTcpClient()
                    Dim c As New Thread(New ParameterizedThreadStart(AddressOf clientLoop))
                    c.IsBackground = True
                    c.Name = "client"
                    c.Start(client)
                Catch e As Exception
                    '                    Console.WriteLine(e.ToString())
                End Try
                Thread.Sleep(1000)
            End While
        End Sub

        Private Sub clientLoop(ByVal client As Object)
            '            Console.WriteLine("starting clientLoop")
            Dim tcp As TcpClient = DirectCast(client, TcpClient)
            Dim stream As Stream = tcp.GetStream()
            Dim br As New BinaryReader(stream)
            Dim buffer As Byte() = New Byte(8191) {}

            While working
                Try
                    If tcp.Connected = False Then
                        Exit Try
                    End If
                    Dim size As Integer = br.ReadInt32()
                    Dim ms As New MemoryStream(size)

                    While size > 0
                        Dim count As Integer = stream.Read(buffer, 0, Math.Min(size, buffer.Length))
                        If count <= 0 Then
                            Exit While
                        End If
                        ms.Write(buffer, 0, count)
                        size -= count
                    End While
                    ms.Position = 0
                    Dim bmp As New Bitmap(ms)
                    Dim mi As MethodInvoker
                    Select Case port
                        Case 17175
                            mi = Sub() form1.PictureBox1.Image = bmp
                        Case 17176
                            mi = Sub() form1.PictureBox2.Image = bmp
                        Case 17177
                            mi = Sub() form1.PictureBox3.Image = bmp
                        Case Else
                            mi = Sub() form1.PictureBox4.Image = bmp
                    End Select
                    form1.BeginInvoke(mi)
                Catch e As Exception
                    '                    Console.WriteLine(e.ToString())
                    Exit Try
                End Try
            End While
            stream.Close()
            tcp.Close()
        End Sub
    End Class

End Namespace


